VERSION 5.00
Object = "{831FDD16-0C5C-11D2-A9FC-0000F8754DA1}#2.0#0"; "mscomctl.ocx"
Begin VB.Form frmGrafici 
   BorderStyle     =   1  'Fixed Single
   Caption         =   " Grafici"
   ClientHeight    =   5160
   ClientLeft      =   45
   ClientTop       =   330
   ClientWidth     =   8895
   Icon            =   "frmGrafici.frx":0000
   LinkTopic       =   "Form1"
   LockControls    =   -1  'True
   MaxButton       =   0   'False
   MDIChild        =   -1  'True
   ScaleHeight     =   5160
   ScaleWidth      =   8895
   Begin VB.CheckBox chkSoloSequenze 
      Alignment       =   1  'Right Justify
      Caption         =   "Solo sequen&ze:"
      Height          =   255
      Left            =   7320
      TabIndex        =   7
      ToolTipText     =   " Disegno dei soli segnali contenenti sequenze valide "
      Top             =   4875
      Width           =   1395
   End
   Begin MSComctlLib.Slider sldViMax 
      Height          =   255
      Left            =   780
      TabIndex        =   2
      Top             =   4860
      Width           =   2115
      _ExtentX        =   3731
      _ExtentY        =   450
      _Version        =   393216
      MousePointer    =   99
      MouseIcon       =   "frmGrafici.frx":0442
      LargeChange     =   1
      Min             =   1
      Max             =   32
      SelStart        =   1
      TickFrequency   =   4
      Value           =   1
   End
   Begin VB.TextBox txtFreqSpettro 
      Height          =   255
      Left            =   5700
      MaxLength       =   1
      TabIndex        =   5
      Top             =   4860
      Width           =   375
   End
   Begin VB.CommandButton cmdBlocca 
      Caption         =   "&Blocca"
      Height          =   255
      Left            =   6420
      TabIndex        =   6
      Top             =   4860
      Width           =   735
   End
   Begin VB.PictureBox picSchermo 
      BackColor       =   &H005B5B2F&
      BeginProperty Font 
         Name            =   "MS Sans Serif"
         Size            =   8.25
         Charset         =   0
         Weight          =   700
         Underline       =   0   'False
         Italic          =   0   'False
         Strikethrough   =   0   'False
      EndProperty
      ForeColor       =   &H00FFFF00&
      Height          =   4680
      Left            =   120
      MousePointer    =   2  'Cross
      ScaleHeight     =   4620
      ScaleWidth      =   8595
      TabIndex        =   0
      TabStop         =   0   'False
      Top             =   60
      Width           =   8655
   End
   Begin VB.Label lblViMax 
      BackStyle       =   0  'Transparent
      Caption         =   "???"
      Height          =   255
      Left            =   2940
      TabIndex        =   3
      Top             =   4875
      Width           =   735
   End
   Begin VB.Label lblScalaVert 
      BackStyle       =   0  'Transparent
      Caption         =   "&Vi Max:"
      Height          =   255
      Left            =   120
      TabIndex        =   1
      Top             =   4875
      Width           =   555
   End
   Begin VB.Label lblCarSpettro 
      BackStyle       =   0  'Transparent
      Caption         =   "Spettro della f&requenza N:"
      Height          =   255
      Left            =   3720
      TabIndex        =   4
      Top             =   4875
      Width           =   1995
   End
End
Attribute VB_Name = "frmGrafici"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
'=======================================================================================
' Descrizione.....: Form per il grafico di toni audio.
' Nome dei Files..: frmGrafici.frm, frmGrafici.frx,
'                   modDecoToni_DTMF.bas, modUtilita.bas
' Data............: 19/03/2004
' Versione........: 1.0 a 32 bits
' Sistema.........: VB6 (SP5) sotto Windows XP (SP2).
' Scritto da......: F. Languasco 
' E-Mail..........: MC7061@mclink.it
' DownLoads a.....: http://www.flanguasco.org
'=======================================================================================
'
Option Explicit
'
Dim NcRX&                   ' N di campioni nei vettori VIn(), vSPM() e VMed()
'
'---------------------------------------------------------------------------------------
'
Dim SSmPixXY() As POINTAPI  ' Vettore SSmPixXY(0 To NcRX) delle posizioni orizzontali
                            ' e verticali dei campioni del segnale e dello spettro [Pixels].
'
Dim CharYPos&           ' Posizione verticale della scritta dei caratteri [Pixels].
'
Dim picSchermo_PixW&    ' Larghezza di picSchermo [Pixels].
Dim picSchermo_PixH&    ' Altezza di picSchermo [Pixels].
'
Dim Ax!, Bx!            ' Coefficienti di trasformazione delle scale per disegnare
Dim Ay!, By!            ' segnale, spettro mobile, valor medio e caratteri con API.
'
Dim hDCh_Q&, hBmp_Q&    ' CompatibleDC e CompatibleBitmap del disegno del quadro.
Dim hDCh_S&, hBmp_S&    ' CompatibleDC e CompatibleBitmap del disegno dei grafici.
'
Const ColRet& = &HAFAFAF    ' Colore dei reticoli.
Const ColSch& = &H5B5B2F    ' Colore di fondo dello schermo.
'
Const ColSig& = vbYellow    ' Colore del segnale.
Const ColVMd& = vbBlue      ' Colore del valor medio.
Const ColSpm& = vbMagenta   ' Colore dello spettro mobile.
Const ColChar& = vbRed      ' Colore dei caratteri.
'
Dim hPen_Sig&           ' Handles delle "penne" per il disegno del segnale.
Dim hPen_VMd&           '    "      "      "     "  "     "     "  valor medio.
Dim hPen_Spm&           '    "      "      "     "  "     "    dello spettro mobile.
Dim hFont&              ' Handle del Font delle scritte sullo schermo.
'
'-- Dichiarazioni, costanti e tipi per API: --------------------------------------------
'
Private Const DRAFT_QUALITY& = 1
Private Const PROOF_QUALITY& = 2
Private Const LF_FACESIZE& = 32
'
Private Const OPAQUE& = 2
Private Const TRANSPARENT& = 1
'
Private Type LOGFONT
    lfHeight As Long
    lfWidth As Long
    lfEscapement As Long
    lfOrientation As Long
    lfWeight As Long
    lfItalic As Byte
    lfUnderline As Byte
    lfStrikeOut As Byte
    lfCharSet As Byte
    lfOutPrecision As Byte
    lfClipPrecision As Byte
    lfQuality As Byte
    lfPitchAndFamily As Byte
    lfFaceName As String * LF_FACESIZE
End Type
'
Private Type POINTAPI
     X As Long          ' [Pixels].
     Y As Long          '     "
End Type
'
Private Declare Function DeleteDC Lib "gdi32" (ByVal hdc As Long) As Long
'
Private Declare Function CreateCompatibleDC Lib "gdi32" _
    (ByVal hdc As Long) As Long
'
Private Declare Function CreateCompatibleBitmap Lib "gdi32" (ByVal hdc As Long, _
    ByVal nWidth As Long, ByVal nHeight As Long) As Long
'
Private Const PS_SOLID& = 0
'
Private Declare Function CreatePen Lib "gdi32" (ByVal nPenStyle As Long, _
    ByVal nWidth As Long, ByVal crColor As Long) As Long
'
Private Declare Function DeleteObject Lib "gdi32" (ByVal hObject As Long) As Long
'
Private Declare Function SelectObject Lib "gdi32" _
    (ByVal hdc As Long, _
    ByVal hObject As Long) As Long
'
Private Declare Function Rectangle Lib "gdi32" (ByVal hdc As Long, _
    ByVal X1 As Long, ByVal Y1 As Long, _
    ByVal X2 As Long, ByVal Y2 As Long) As Long
'
Private Declare Function Ellipse Lib "gdi32" (ByVal hdc As Long, _
    ByVal X1 As Long, ByVal Y1 As Long, _
    ByVal X2 As Long, ByVal Y2 As Long) As Long
'
Private Declare Function MoveToEx Lib "gdi32" (ByVal hdc As Long, _
    ByVal X As Long, ByVal Y As Long, ByVal lpPoint As Long) As Long
'
Private Declare Function LineTo Lib "gdi32" (ByVal hdc As Long, _
    ByVal X As Long, ByVal Y As Long) As Long
'
Private Declare Function Polyline Lib "gdi32" (ByVal hdc As Long, _
    lpPoint As POINTAPI, ByVal nCount As Long) As Long
'
Private Declare Function CreateFontIndirect Lib "gdi32" Alias "CreateFontIndirectA" _
    (lpLogFont As LOGFONT) As Long
'
Private Declare Function SetTextColor Lib "gdi32" _
    (ByVal hdc As Long, ByVal crColor As Long) As Long
Private Declare Function SetBkColor Lib "gdi32" _
    (ByVal hdc As Long, ByVal crColor As Long) As Long
Private Declare Function SetBkMode Lib "gdi32" (ByVal hdc As Long, ByVal nBkMode As Long) As Long
'
Private Declare Function TextOut Lib "gdi32" Alias "TextOutA" _
    (ByVal hdc As Long, ByVal X As Long, ByVal Y As Long, _
    ByVal lpString As String, ByVal nCount As Long) As Long
'
Private Const SRCCOPY& = &HCC0020   ' (DWORD) dest = source
'
Private Declare Function BitBlt Lib "gdi32" _
    (ByVal hDestDC As Long, ByVal X As Long, ByVal Y As Long, _
    ByVal nWidth As Long, ByVal nHeight As Long, ByVal hSrcDC As Long, _
    ByVal xSrc As Long, ByVal ySrc As Long, ByVal dwRop As Long) As Long
'
Private Declare Function GetCursorPos Lib "USER32" (lpPoint As POINTAPI) As Long
Private Declare Function ScreenToClient Lib "USER32" (ByVal hWnd As Long, _
    lpPoint As POINTAPI) As Long
Private Declare Function ClientToScreen Lib "USER32" (ByVal hWnd As Long, _
    lpPoint As POINTAPI) As Long
'
Private Const RDW_UPDATENOW& = &H100
Private Const RDW_INVALIDATE& = &H1
Private Const fuRedraw& = RDW_UPDATENOW Or RDW_INVALIDATE
'
Private Declare Function RedrawWindow Lib "USER32" _
    (ByVal hWnd As Long, lprcUpdate As Any, ByVal hrgnUpdate As Long, _
    ByVal fuRedraw As Long) As Long
Public Sub Apri(Optional ByVal NcRX_I As Long)
'
'
    NcRX = NcRX_I
    sldViMax.Value = Int(ViMax / 1000!)
'
    DisegnaQuadro
'
    Me.ZOrder vbSendToBack
'
'
'
End Sub

Private Sub chkSoloSequenze_Click()
'
'
    bSoloSequenze = (chkSoloSequenze.Value = vbChecked)
'
'
'
End Sub
Private Sub cmdBlocca_Click()
'
'
    bDisegnaGrafici = (Not bDisegnaGrafici)
    cmdBlocca.Caption = IIf(bDisegnaGrafici, "&Blocca", "&Disegna")
'
'
'
End Sub
Private Sub Form_Load()
'
'
    Dim Me_L&, Me_T&, ITr&, lRet&
'
    LeggiPosizioneFormINI FileINI$, Me, Me_L, Me_T
    Me.Move Me_L, Me_T
'
    txtFreqSpettro.Text = "0"
    chkSoloSequenze.Value = vbUnchecked
'
    CloseButtonDisable Me
'
    bDisegnaGrafici = True
'
'
'
End Sub
Public Sub DisegnaGrafici_DTMF(VIn() As Single, vSPM() As Double, VMed() As Double, _
    ByVal NChar As Long, PosChar() As Long, Char$())
'
'   Visualizza il segnale della sequenza, lo spettro mobile,
'   il valor medio e scrive i caratteri trovati:
'
    Dim I&
'
    On Error GoTo DisegnaGrafici_DTMF_ERR
'
    ' Copio il quadro sull' hDCh_S dello schermo:
    Call BitBlt(hDCh_S, 0, 0, picSchermo_PixW, picSchermo_PixH, hDCh_Q, 0, 0, SRCCOPY)
'
'---------------------------------------------------------------------------------------
'
    ' Disegno il segnale:
    For I = 1 To NcRX
        SSmPixXY(I).Y = Ay * VIn(I) + By
    Next I
'
    Call SelectObject(hDCh_S, hPen_Sig)
    Call Polyline(hDCh_S, SSmPixXY(1), NcRX)
'
    ' Disegno lo spettro mobile:
    For I = 1 To NcRX
        SSmPixXY(I).Y = Ay * vSPM(I) + By
    Next I
'
    Call SelectObject(hDCh_S, hPen_Spm)
    Call Polyline(hDCh_S, SSmPixXY(1), NcRX)
'
'    ' Disegno il valor medio:
    For I = 1 To NcRX
        SSmPixXY(I).Y = Ay * VMed(I) + By
    Next I
'
    Call SelectObject(hDCh_S, hPen_VMd)
    Call Polyline(hDCh_S, SSmPixXY(1), NcRX)
'
    ' Scrivo i caratteri eventualmente decodificati:
    For I = 1 To NChar
        If (1 <= PosChar(I)) And (PosChar(I) <= NcRX) Then
            Call TextOut(hDCh_S, SSmPixXY(PosChar(I)).X, CharYPos, Char$(I), 1)
        End If
    Next I
'
'---------------------------------------------------------------------------------------
'
    ' Copio l' hDCh_S dello schermo su picSchermo:
    picSchermo.Cls
    Call BitBlt(picSchermo.hdc, 0, 0, picSchermo_PixW, picSchermo_PixH, _
                hDCh_S, 0, 0, SRCCOPY)
'
    Exit Sub
'
'
DisegnaGrafici_DTMF_ERR:
    Err.Clear
'
'
'
End Sub
Private Sub Form_Unload(Cancel As Integer)
'
'
    Dim lRet&
'
    SalvaPosizioneFormINI FileINI$, Me
'
    ' Elimino gli handles correnti:
    lRet = DeleteDC(hDCh_Q)
    lRet = DeleteDC(hDCh_S)
    lRet = DeleteObject(hBmp_Q)
    lRet = DeleteObject(hBmp_S)
    lRet = DeleteObject(hPen_Sig)
    lRet = DeleteObject(hPen_VMd)
    lRet = DeleteObject(hPen_Spm)
    lRet = DeleteObject(hFont)
'
    Set frmGrafici = Nothing
'
'
'
End Sub
Private Sub sldViMax_Change()
'
'
    ViMax = sldViMax.Value * 1000!
    lblViMax = ViMax
    DisegnaQuadro
'
'
'
End Sub
Private Sub picSchermo_MouseMove(Button As Integer, Shift As Integer, X As Single, Y As Single)
'
'
    picSchermo.ToolTipText = " " & Format$(X, "#0") & ",  " & Format$(Y, "#0") & " "
'
'
'
End Sub
Private Sub txtFreqSpettro_Change()
'
'
    If (Val(txtFreqSpettro.Text) < 0) Then txtFreqSpettro.Text = 0
    If (Val(7 < txtFreqSpettro.Text)) Then txtFreqSpettro.Text = 7
    IFreqSpettro = Val(txtFreqSpettro.Text)
'
'
'
End Sub
Private Sub txtFreqSpettro_KeyPress(KeyAscii As Integer)
'
'
    KeyAscii = KAscNumInteri(KeyAscii)
'
'
'
End Sub
Private Sub DisegnaQuadro()
'
'   Prepara i quadri dei grafici:
'
    Dim I&, lRet&
'
    Dim QxMin!, QxMax!  ' Ascisse min. e max. dello schermo [vbUser].
    Dim QyMin!, QyMax!  ' Ordinate "   "  "     "      "       "
'
    Dim lpLogFont As LOGFONT
'
    On Error Resume Next    ' Serve in fase di inizializzazione.
'
    picSchermo.ScaleMode = vbPixels
    picSchermo_PixW = picSchermo.ScaleWidth
    picSchermo_PixH = picSchermo.ScaleHeight
'
    Quadro picSchermo, 0#, -ViMax, CDbl(NcRX), ViMax, , , , , , , , _
           "Segnale", "Nc", "Vi", True, , , , , , , QxMin, QyMin, QxMax, QyMax, _
           ColRet, ColSch
'
'---------------------------------------------------------------------------------------
'   Preparo variabili, handles, etc... per disegnare
'   lo schermo con API.
'
    ' Calcolo i coefficienti di trasformazione da vbUser a vbPixels per
    ' evitare, nella Sub DisegnaCepstrum, l' uso dei metodi ScaleX e ScaleY.
    ' Coefficienti per la trasformazione delle ascisse:
    Ax = picSchermo_PixW / (QxMax - QxMin)
    Bx = picSchermo_PixW * QxMin / (QxMin - QxMax)
'
    ' Coefficienti per la trasformazione delle ordinate:
    Ay = picSchermo_PixH / (QyMin - QyMax)
    By = picSchermo_PixH * QyMax / (QyMax - QyMin)
'
    ' Calcolo, in Pixels, le posizioni orizzontali
    ' dei campioni e dei caratteri sullo schermo:
    ReDim SSmPixXY(1 To NcRX)
    For I = 1 To NcRX
        SSmPixXY(I).X = Ax * CSng(I) + Bx
    Next I
'
    ' Posizione verticale, in Pixels, della scritta dei caratteri:
    CharYPos = 20 + picSchermo_PixH / 2
'
    ' Elimino gli handles correnti:
    lRet = DeleteDC(hDCh_Q)
    lRet = DeleteDC(hDCh_S)
    lRet = DeleteObject(hBmp_Q)
    lRet = DeleteObject(hBmp_S)
    lRet = DeleteObject(hPen_Sig)
    lRet = DeleteObject(hPen_VMd)
    lRet = DeleteObject(hPen_Spm)
    lRet = DeleteObject(hFont)
'
    ' BitMap del quadro:
    hDCh_Q = CreateCompatibleDC(picSchermo.hdc)
    hBmp_Q = CreateCompatibleBitmap(picSchermo.hdc, picSchermo_PixW, picSchermo_PixH)
    lRet = SelectObject(hDCh_Q, hBmp_Q)
'
    ' BitMap del segnale, del valor medio e dello spettro mobile:
    hDCh_S = CreateCompatibleDC(picSchermo.hdc)
    hBmp_S = CreateCompatibleBitmap(picSchermo.hdc, picSchermo_PixW, picSchermo_PixH)
    lRet = SelectObject(hDCh_S, hBmp_S)
'
    ' Creo ed assegno il "Font" necessario
    ' alla scrittura dei caratteri:
    lpLogFont.lfEscapement = 0
    lpLogFont.lfOrientation = 0
    lpLogFont.lfQuality = PROOF_QUALITY
    lpLogFont.lfFaceName = "MS Sans Serif" & Chr$(0)
    lpLogFont.lfWeight = 600
    lpLogFont.lfHeight = 25
    hFont = CreateFontIndirect(lpLogFont)
    lRet = SelectObject(hDCh_S, hFont)
'
    ' Imposto i colori delle
    ' scritte sullo schermo:
    SetTextColor hDCh_S, ColChar
    'SetBkColor hDCh_S, vbWhite      ' Forse meglio
    SetBkMode hDCh_S, TRANSPARENT   ' di questo...
'
    ' Creo la "penna" necessaria al disegno del segnale:
    hPen_Sig = CreatePen(PS_SOLID, 1, ColSig)
'
    ' Creo la "penna" necessaria alla scritta del valor medio:
    hPen_VMd = CreatePen(PS_SOLID, 1, ColVMd)
'
    ' Creo la "penna" necessaria alla scritta dello spettro mobile:
    hPen_Spm = CreatePen(PS_SOLID, 1, ColSpm)
'
    ' Copio il quadro sull' hDCh_Q dello sfondo:
    lRet = BitBlt(hDCh_Q, 0, 0, picSchermo_PixW, picSchermo_PixH, _
                  picSchermo.hdc, 0, 0, SRCCOPY)
'
'
    If (Err.Number <> 0) Then Err.Clear
'
'
'
End Sub
