VERSION 5.00
Begin VB.MDIForm frmDecoToni_DTMF 
   BackColor       =   &H8000000C&
   Caption         =   " Decodifica toni DTMF"
   ClientHeight    =   6510
   ClientLeft      =   165
   ClientTop       =   735
   ClientWidth     =   9480
   Icon            =   "frmDecoToni_DTMF.frx":0000
   LinkTopic       =   "MDIForm1"
   LockControls    =   -1  'True
   StartUpPosition =   3  'Windows Default
   Begin VB.Menu mnuFile 
      Caption         =   "&File"
      Begin VB.Menu mnuEsci 
         Caption         =   "&Esci"
      End
   End
   Begin VB.Menu mnuOpzioni 
      Caption         =   "&Opzioni"
   End
   Begin VB.Menu mnuFinestre 
      Caption         =   "Fi&nestre"
      WindowList      =   -1  'True
   End
   Begin VB.Menu mnuQM 
      Caption         =   "&?"
      Begin VB.Menu mnuIstruzioni 
         Caption         =   "&Istruzioni"
      End
      Begin VB.Menu zSep01 
         Caption         =   "-"
      End
      Begin VB.Menu mnuInformazioni 
         Caption         =   "Informazioni su &DecoToni"
      End
   End
End
Attribute VB_Name = "frmDecoToni_DTMF"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
'=======================================================================================
' Descrizione.....: Progetto per la generazione e la decodifica
'                   di toni audio di tipo DTMF.
' Nome dei Files..: frmDecoToni_DTMF.frm, frmDecoToni_DTMF.frx,
'                   frmConsole.frm, frmConsole.frx,
'                   frmOpzioni.frm, frmOpzioni.frx,
'                   frmGrafici.frm, frmGrafici.frx,
'                   frmTastieraDTMF.frm, frmTastieraDTMF.frx,
'                   frmInfoCr.frm, frmInfoCr.frx,
'                   frmIstruzioni.frm, frmIstruzioni.frx,
'                   modDecoToni_DTMF_DTMF.bas, modDSP.bas, modComplex.bas,
'                   modCodici.bas, modUtilita.bas, modFlexPB.bas,
'                   modMixerControl.bas, modCommonDialog.
' Data............: 08/03/2004 (Ver. 1.0, Selettive).
' Aggiornamento...: 19/03/2004 (Ver. 2.1).
' Aggiornamento...: 11/01/2005 (Ver. 2.2, aggiunta la decodifica sequenze -> testi)
' Aggiornamento...: 05/07/2007 (Ver. 3.0 per DTMF).
' Aggiornamento...: 26/03/2010 (Ver. 4.0, nuova versione della gestione delle
'                               schede audio, etc...).
' Versione........: 4.0 a 32 bits.
' Sistema.........: VB6 (SP5) sotto Windows XP (SP2).
' Scritto da......: F. Languasco 
' E-Mail..........: MC7061@mclink.it
' DownLoads a.....: http://www.flanguasco.org
'=======================================================================================
'
Option Explicit
'
Private bStatoScreenSaver As Boolean    ' Stato dello ScreenSaver al lancio del programma.
Private Sub MDIForm_Load()
'
'
    Dim Me_L&, Me_T&, Me_W&, Me_H&
'
    LeggiPosizioneFormINI FileINI$, Me, Me_L, Me_T, Me_W, Me_H, True
    Me.Move Me_L, Me_T, Me_W, Me_H
'
    hWndCmdlgOwnerForm = Me.hWnd    ' I Common Dialogs appariranno come modali
                                    ' rispetto a questa applicazione.
'
    bStatoScreenSaver = ScreenSaver(False)
'
'    frmTastiera_DTMF.Show
'    frmConsole.Show
'
'
'
End Sub
Private Sub MDIForm_Unload(Cancel As Integer)
'
'
    ScreenSaver bStatoScreenSaver
    SalvaParametri
'
    SalvaPosizioneFormINI FileINI$, Me, True
'
'
'
End Sub
Private Sub mnuEsci_Click()
'
'
    Unload Me
'
'
'
End Sub

Private Sub mnuInformazioni_Click()
'
'
    frmCopyright.Apri frmDecoToni_DTMF
'
'
'
End Sub
Private Sub mnuIstruzioni_Click()
'
'
    frmIstruzioni.Apri App.Path & "\Istruzioni.rtf", " Istruzioni", vbStartUpScreen
'
'
'
End Sub
Private Sub mnuOpzioni_Click()
'
'
    Dim M$
'
    If bAcqOn Or bSuonaOn Then
        M$ = "L' acquisizione e/o l' emissione continua sono in corso."
        M$ = M$ & vbNewLine & vbNewLine
        M$ = M$ & "Per poter usare le Opzioni occorre fermarle con: [Stop] e/o [Rip.]."
        MsgBox M$, vbInformation, " Opzioni"
'
    Else
        frmOpzioni.Show
    End If
'
'
'
End Sub

Public Sub AbilitaControlli(ByVal bAbilita As Boolean)
'
'
    ' Su frmDecoToni_DTMF:
    mnuOpzioni.Enabled = bAbilita And (Not (bAcqOn Or bSuonaOn))
    mnuEsci.Enabled = bAbilita And (Not (bAcqOn Or bSuonaOn))
'
    ' Su frmConsole:
    frmConsole.cmdInvio.Enabled = bAbilita And (frmConsole.txtSeqTX.Text <> "")
'
    frmConsole.lblToneWidth.Enabled = bAbilita
    frmConsole.txtToneWidth.Enabled = bAbilita
    frmConsole.updToneWidth.Enabled = bAbilita
    frmConsole.lblToneWidthU.Enabled = bAbilita
'
    frmConsole.lblInToneGap.Enabled = bAbilita
    frmConsole.txtInToneGap.Enabled = bAbilita
    frmConsole.updInToneGap.Enabled = bAbilita
    frmConsole.lblInToneGapU.Enabled = bAbilita
'
    frmConsole.cmdEsci.Enabled = bAbilita And (Not (bAcqOn Or bSuonaOn))
'
    ' Su frmTastiera_DTMF:
    frmTastiera_DTMF.cmdRP.Enabled = bAbilita And (frmTastiera_DTMF.lblSequenza.Caption <> "")
    ContainerEnabled frmTastiera_DTMF.fraTastiera, bAbilita
'
'
'
End Sub
