VERSION 5.00
Object = "{3B7C8863-D78F-101B-B9B5-04021C009402}#1.2#0"; "RICHTX32.OCX"
Object = "{831FDD16-0C5C-11D2-A9FC-0000F8754DA1}#2.0#0"; "mscomctl.ocx"
Begin VB.Form frmIstruzioni 
   AutoRedraw      =   -1  'True
   Caption         =   " Istruzioni:"
   ClientHeight    =   4110
   ClientLeft      =   60
   ClientTop       =   345
   ClientWidth     =   7680
   Icon            =   "frmIstruzioni.frx":0000
   LinkTopic       =   "Form1"
   LockControls    =   -1  'True
   MDIChild        =   -1  'True
   ScaleHeight     =   4110
   ScaleWidth      =   7680
   Begin MSComctlLib.StatusBar staSizeGrip 
      Align           =   2  'Align Bottom
      Height          =   255
      Left            =   0
      TabIndex        =   1
      Top             =   3855
      Width           =   7680
      _ExtentX        =   13547
      _ExtentY        =   450
      Style           =   1
      SimpleText      =   "File:"
      _Version        =   393216
      BeginProperty Panels {8E3867A5-8586-11D1-B16A-00C0F0283628} 
      EndProperty
   End
   Begin RichTextLib.RichTextBox rtfIstruzioni 
      Height          =   3855
      Left            =   0
      TabIndex        =   0
      Top             =   0
      Width           =   7665
      _ExtentX        =   13520
      _ExtentY        =   6800
      _Version        =   393217
      BackColor       =   -2147483624
      ReadOnly        =   -1  'True
      ScrollBars      =   3
      TextRTF         =   $"frmIstruzioni.frx":0442
   End
End
Attribute VB_Name = "frmIstruzioni"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
'=======================================================================================
' Descrizione.....: Form, di uso generale, per la visualizzazione
'                   di un File di istruzioni.
' Nome dei Files..: frmIstruzioni.frm, frmIstruzioni.frx
' Data............: 15/09/1999
' Aggiornamento...: 05/11/2006
' Aggiornamento...: 12/06/2007 (Ver. 1.2).
' Versione........: 1.2 a 32 Bits.
' Sistema.........: VB6 (SP5) sotto Windows XP (SP2).
' Scritto da......: F. Languasco 
' E-Mail..........: MC7061@mclink.it
' DownLoads a.....: http://www.flanguasco.org
'=======================================================================================
'
'   Nel Form di origine usare il codice:
'    frmIstruzioni.Apri FileIstruzioni$ [, Titolo$] [, Posizione&] _
                        [, FormWidth&] [, FormHeight&] [, SForm as Form]
'
'     FileIstruzioni$:  nome, completo di path e di tipo .txt o .rtf,
'                       del file con le istruzioni da visualizzare.
'     Titolo$:          Caption di questo Form [opzionale].
'     Posizione:        posizione iniziale di questo Form [opzionale]
'                       e puo' essere solo:
'                        0 = in alto, a destra, del Form di origine.
'                        1 = in centro al Form di origine (vbStartUpOwner).
'                        2 = in centro allo schermo o al Form MDI
'                            ospitante (default) (vbStartUpScreen).
'                        3 = in alto, a sinistra dello schermo o del
'                            Form MDI ospitante (vbStartUpWindowsDefault).
'                        Se Posizione = 0  o Posizione = 1
'                        deve essere anche presente SForm.
'     FormWidth:        larghezza iniziale di questo Form [Twips].
'     FormHeight:       altezza iniziale di questo Form [Twips].
'     SForm:            Form da cui e' stata lanciata la richiesta.
'
Option Explicit
'
Private SForm As Form
Private Posizione&
Private FormWidth&, FormHeight&
'
Private Type RECT
    Left  As Long       ' [Pixels].
    Top  As Long        '    "
    Right  As Long      '    "
    Bottom  As Long     '    "
End Type
'
Private Declare Function GetParent Lib "USER32" (ByVal hWnd As Long) As Long
Private Declare Function GetWindowRect Lib "USER32" (ByVal hWnd As Long, _
    lpRECT As RECT) As Long
Private Function FileExists(ByVal FileN$) As Boolean
'
'   Verifica l' esistenza del file FileN$:
'
    Dim lRet&
'
    On Error Resume Next
'
    lRet = FileLen(FileN$)
    FileExists = (Err.Number = 0)
    Err.Clear
'
'
'
End Function
Private Sub Form_Load()
'
'
    Dim X&, Y&, PForm_Width&, PForm_Height&
    Dim lpRECT As RECT
'
    On Error Resume Next
'
    Select Case Posizione
    Case 0
        ' Posizionamento in alto a destra del Form di origine:
        X = SForm.Left + SForm.Width - Me.Width
        Y = SForm.Top
'
    Case vbStartUpOwner
        ' Posizionamento in centro al Form di origine:
        X = SForm.Left + (SForm.Width - Me.Width) / 2
        Y = SForm.Top + (SForm.Height - Me.Height) / 2
'
    Case vbStartUpScreen
        ' Posizionamento in centro allo schermo o all' MDI:
        If Me.MDIChild Then
            GetWindowRect GetParent(Me.hWnd), lpRECT
            PForm_Width = Abs(lpRECT.Right - lpRECT.Left) _
                        * Screen.TwipsPerPixelX
            PForm_Height = Abs(lpRECT.Bottom - lpRECT.Top) _
                         * Screen.TwipsPerPixelY
            X = (PForm_Width - Me.Width) / 2
            Y = (PForm_Height - Me.Height) / 2
        Else
            X = (Screen.Width - Me.Width) / 2
            Y = (Screen.Height - Me.Height) / 2
        End If
'
    Case vbStartUpWindowsDefault
        ' Posizionamento in alto a sinistra dello schermo
        ' o dell' MDI:
        X = 0
        Y = 0
    End Select
'
    Me.Move X, Y, FormWidth, FormHeight
'
'
    If (Err.Number <> 0) Then Err.Clear
'
'
'
End Sub
Private Sub Form_Resize()
'
'
    Dim rtfIsW&, rtfIsH&
'
    If (Me.WindowState <> vbMinimized) Then
        rtfIsW = Me.Width - 120
        If (rtfIsW < 1) Then rtfIsW = 1
        rtfIsH = Me.Height - 645
        If (rtfIsH < 1) Then rtfIsH = 1
'
        rtfIstruzioni.Move 0, 0, rtfIsW, rtfIsH
    End If
'
'
'
End Sub
Public Sub Apri(ByVal FileIstruzioni$, Optional ByVal Titolo$ = "Istruzioni", _
    Optional ByVal Posizione_I As Long = vbStartUpScreen, _
    Optional FormWidth_I As Long = 9600, Optional FormHeight_I As Long = 7200, _
    Optional ByVal Sform_I As Form)
'
'
    Posizione = Posizione_I
    FormWidth = FormWidth_I
    FormHeight = FormHeight_I
    Set SForm = Sform_I
    Me.Caption = " " & Titolo$
'
    Me.Show
    Me.WindowState = vbNormal
'
    If FileExists(FileIstruzioni$) Then
        rtfIstruzioni.LoadFile FileIstruzioni$
        staSizeGrip.SimpleText = "File: " & FileIstruzioni$
'
    Else
        MsgBox "Manca il file " & FileIstruzioni$, vbCritical, _
               " frmIstruzioni: Apri"
        Unload Me
    End If
'
'
'
End Sub
Private Sub Form_Unload(Cancel As Integer)
'
'
    Set frmIstruzioni = Nothing
'
'
'
End Sub
