VERSION 5.00
Begin VB.Form frmTastieraDTMF 
   BorderStyle     =   1  'Fixed Single
   Caption         =   " Tastiera DTMF"
   ClientHeight    =   3375
   ClientLeft      =   45
   ClientTop       =   330
   ClientWidth     =   3075
   Icon            =   "frmTastieraDTMF.frx":0000
   KeyPreview      =   -1  'True
   LinkTopic       =   "Form1"
   LockControls    =   -1  'True
   MaxButton       =   0   'False
   MDIChild        =   -1  'True
   ScaleHeight     =   3375
   ScaleWidth      =   3075
   Begin VB.Frame fraTastiera 
      Height          =   2415
      Left            =   240
      TabIndex        =   3
      Top             =   720
      Width           =   2595
      Begin VB.Timer tmrAbilita 
         Enabled         =   0   'False
         Left            =   840
         Top             =   180
      End
      Begin VB.CommandButton cmdKeyDTMF 
         Caption         =   "1"
         BeginProperty Font 
            Name            =   "MS Sans Serif"
            Size            =   9.75
            Charset         =   0
            Weight          =   700
            Underline       =   0   'False
            Italic          =   0   'False
            Strikethrough   =   0   'False
         EndProperty
         Height          =   495
         Index           =   0
         Left            =   120
         MouseIcon       =   "frmTastieraDTMF.frx":0442
         MousePointer    =   99  'Custom
         Style           =   1  'Graphical
         TabIndex        =   4
         TabStop         =   0   'False
         Top             =   180
         Width           =   555
      End
   End
   Begin VB.CommandButton cmdCancellaSeq 
      Enabled         =   0   'False
      Height          =   315
      Left            =   2460
      MaskColor       =   &H8000000F&
      Picture         =   "frmTastieraDTMF.frx":074C
      Style           =   1  'Graphical
      TabIndex        =   1
      ToolTipText     =   "Cancella sequenza "
      Top             =   240
      UseMaskColor    =   -1  'True
      Width           =   390
   End
   Begin VB.CommandButton cmdRP 
      Caption         =   "RP"
      Enabled         =   0   'False
      Height          =   315
      Left            =   2040
      TabIndex        =   0
      ToolTipText     =   "Ripeti sequenza "
      Top             =   240
      Width           =   375
   End
   Begin VB.Label lblSequenza 
      BorderStyle     =   1  'Fixed Single
      Height          =   315
      Left            =   240
      TabIndex        =   2
      Top             =   240
      Width           =   1695
      WordWrap        =   -1  'True
   End
End
Attribute VB_Name = "frmTastieraDTMF"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
'========================================================================
' Descrizione.....: Form per la generazione, con tastiera, dei toni DTMF.
' Nome dei Files..: frmTastieraDTMF.frm, frmTastieraDTMF.frx,
'                   modDecoToni.bas, modUtilita.bas
' Data............: 07/07/2005
' Versione........: 1.0 a 32 bits
' Sistema.........: VB6 (SP5) sotto Windows NT (SP6).
' Scritto da......: F. Languasco 
' E-Mail..........: MC7061@mclink.it
' DownLoads a.....: http://www.flanguasco.org
'                   http://members.xoom.it/flanguasco/
'========================================================================
'
Option Explicit
'
Dim bKDown As Boolean   ' Flag di tasto premuto.
'
Dim IChar%              ' Indice del carattere selezionato.
'
Const MaxToneWidth# = 3 ' Durata massima di un tono [s].
Private Sub cmdCancellaSeq_Click()
'
'
    lblSequenza.Caption = ""
'
'
'
End Sub
Private Sub cmdKeyDTMF_MouseDown(Index As Integer, Button As Integer, Shift As Integer, X As Single, Y As Single)
'
'
    cmdKeyDTMF(Index).BackColor = vbGreen
'
    Call IniziaSuonoSequenza(MixerSp(MixerSpI).SchedaAudioID, _
                             ToneChar$(Index), MaxToneWidth)
    Call SuonaSequenza
'
    lblSequenza = lblSequenza & ToneChar$(Index)
'
'
'
End Sub
Private Sub cmdKeyDTMF_MouseUp(Index As Integer, Button As Integer, Shift As Integer, X As Single, Y As Single)
'
'
    Call TerminaSuonoSequenza
'
    cmdKeyDTMF(Index).BackColor = vbButtonFace
'
'
'
End Sub
Private Sub cmdRP_Click()
'
'
    cmdRP.Enabled = False
    ContainerEnabled fraTastiera, False
'
    Call IniziaSuonoSequenza(MixerSp(MixerSpI).SchedaAudioID, _
                             lblSequenza.Caption, ToneWidth)
    Call SuonaSequenza
    Call TerminaSuonoSequenza(True)
'
    tmrAbilita.Interval = 1000 * Len(lblSequenza.Caption) * (InToneGap + ToneWidth) + 300
    tmrAbilita.Enabled = True
'
'
'
End Sub
Private Sub Form_KeyPress(KeyAscii As Integer)
'
'
    If bKDown Then Exit Sub
    bKDown = True
'
    KeyAscii = Asc(UCase$(Chr$(KeyAscii)))
'
    If Chr$(KeyAscii) = "R" Then
        cmdRP_Click
        Exit Sub
    End If
'
    IChar = CodeToInd(Chr$(KeyAscii))
    If IChar >= 0 Then
        cmdKeyDTMF_MouseDown IChar, vbLeftButton, 0, 0, 0
    End If
'
'
'
End Sub
Private Sub Form_KeyUp(KeyCode As Integer, Shift As Integer)
'
'
    bKDown = False
'
    If IChar >= 0 Then
        cmdKeyDTMF_MouseUp IChar, vbLeftButton, 0, 0, 0
    End If
'
'
'
End Sub
Private Sub Form_Load()
'
'
    Dim Me_L&, Me_T&
    Dim I&, J&, K&, PosX&, PosY&
'
    LeggiPosizioneFormINI FileINI$, Me, Me_L, Me_T
    Me.Move Me_L, Me_T
'
    PosX = cmdKeyDTMF(0).Left
    PosY = cmdKeyDTMF(0).Top
'
    ' Creo i tasti mancanti:
    For K = 1 To 15
        Load cmdKeyDTMF(K)
        cmdKeyDTMF(K).Caption = ToneChar$(K)
        cmdKeyDTMF(K).Visible = True
    Next K
'
    ' e li sistemo nella loro
    ' posizione sulla tastiera:
    K = 0
    For J = 0 To 3
        For I = 0 To 3
            cmdKeyDTMF(K).Left = PosX + I * (cmdKeyDTMF(0).Width + 45)
            cmdKeyDTMF(K).Top = PosY + J * (cmdKeyDTMF(0).Height + 45)
            K = K + 1
        Next I
    Next J
'
'
'
End Sub
Private Sub Form_Unload(Cancel As Integer)
'
'
    SalvaPosizioneFormINI FileINI$, Me
'
'
'
End Sub
Private Sub lblSequenza_Change()
'
'
    cmdRP.Enabled = (lblSequenza.Caption <> "")
    cmdCancellaSeq.Enabled = (lblSequenza.Caption <> "")
'
'
'
End Sub

Private Sub tmrAbilita_Timer()
'
'
    cmdRP.Enabled = True
    ContainerEnabled fraTastiera, True
'
    tmrAbilita.Enabled = False
'
'
'
End Sub
